/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.9 Revision 1.359
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.9 2002/12/01 15:48:27 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.359 2011/07/20 05:46:46 vapier Exp $
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
10ECLASS=eutils 5# @ECLASS: eutils.eclass
11INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
12 17
13newdepend sys-devel/patch 18inherit multilib portability
14 19
15DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
16 21
17# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
18# libs in /lib. This is to fix linking problems when you have
19# the .so in /lib, and the .a in /usr/lib. What happens is that
20# in some cases when linking dynamic, the .a in /usr/lib is used
21# instead of the .so in /lib due to gcc/libtool tweaking ld's
22# library search path. This cause many builds to fail.
23# See bug #4411 for more info.
24#
25# To use, simply call:
26#
27# gen_usr_ldscript libfoo.so
28#
29# Note that you should in general use the unversioned name of
30# the library, as ldconfig should usually update it correctly
31# to point to the latest version of the library present.
32#
33# <azarah@gentoo.org> (26 Oct 2002)
34#
35gen_usr_ldscript() {
36 23
37 # Just make sure it exists 24# @FUNCTION: epause
38 dodir /usr/lib 25# @USAGE: [seconds]
39 26# @DESCRIPTION:
40 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
41/* GNU ld script 28# printing a message the user should probably be reading and often used in
42 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
43 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
44 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
45 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
46 See bug #4411 on http://bugs.gentoo.org/ for
47 more info. */
48GROUP ( /lib/libxxx )
49END_LDSCRIPT
50
51 dosed "s:libxxx:$1:" /usr/lib/$1
52
53 return 0
54} 33}
55 34
56# Simple function to draw a line consisting of '=' the same length as $* 35# @FUNCTION: ebeep
57# 36# @USAGE: [number of beeps]
58# <azarah@gentoo.org> (11 Nov 2002) 37# @DESCRIPTION:
59# 38# Issue the specified number of beeps (default of 5 beeps). Useful when
60draw_line() { 39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
61 local i=0 43 local n
62 local str_length="" 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
63 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
64 # Handle calls that do not have args, or wc not being installed ...
65 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
66 then
67 echo "==============================================================="
68 return 0
69 fi
70
71 # Get the length of $*
72 str_length="$(echo -n "$*" | wc -m)"
73
74 while [ "$i" -lt "${str_length}" ]
75 do
76 echo -n "=" 46 echo -ne "\a"
77 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
78 i=$((i + 1)) 48 echo -ne "\a"
49 sleep 1
79 done 50 done
51 fi
52}
80 53
81 echo 54else
82 55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
83 return 0 116# return 0
117# fi
118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
84} 134}
85 135
86# Default directory where patches are located 136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
154
155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
90# Default options for patch 165# Default options for patch:
91EPATCH_OPTS="" 166# @CODE
167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
168# --no-backup-if-mismatch - do not leave .orig files behind
169# -E - automatically remove empty files
170# @CODE
171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
93# and not the full path .. 175# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
95# Change the printed message for a single patch. 179# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
183# Change the printed message for multiple patches.
184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
185# @VARIABLE: EPATCH_FORCE
186# @DESCRIPTION:
187# Only require patches to match EPATCH_SUFFIX rather than the extended
188# arch naming style.
189EPATCH_FORCE="no"
97 190
98# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
99# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
100# 199#
101# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
102# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
103# 202#
104# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
105# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
106# 205# if ${EPATCH_FORCE} != "yes"
107# Above EPATCH_* variables can be used to control various defaults,
108# bug they should be left as is to ensure an ebuild can rely on
109# them for.
110#
111# Patches are applied in current directory.
112#
113# Bulk Patches should preferibly have the form of:
114#
115# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
116# 215#
117# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
118# 218#
119# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
120# 02_sparc_another-fix.patch.bz2
121#
122# This ensures that there are a set order, and you can have ARCH
123# specific patches.
124#
125# If you however give an argument to epatch(), it will treat it as a
126# single patch that need to be applied if its a file. If on the other
127# hand its a directory, it will set EPATCH_SOURCE to this.
128#
129# <azarah@gentoo.org> (10 Nov 2002)
130#
131epatch() { 220epatch() {
132 local PIPE_CMD="" 221 _epatch_draw_line() {
133 local STDERR_TARGET="${T}/$$.out" 222 # create a line of same length as input string
134 local PATCH_TARGET="${T}/$$.patch" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
135 local PATCH_SUFFIX="" 224 echo "${1//?/=}"
225 }
226
227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
228
229 # Let the rest of the code process one user arg at a time --
230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
233 local m
234 for m in "$@" ; do
235 epatch "${m}"
236 done
237 return 0
238 fi
239
136 local SINGLE_PATCH="no" 240 local SINGLE_PATCH="no"
241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
245 SINGLE_PATCH="yes"
246 set -- "$1"
247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
249 local EPATCH_SUFFIX=$1
250
251 elif [[ -d $1 ]] ; then
252 # Some people like to make dirs of patches w/out suffixes (vim)
253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
254
255 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
256 # Re-use EPATCH_SOURCE as a search dir
257 epatch "${EPATCH_SOURCE}/$1"
258 return $?
259
260 else
261 # sanity check ... if it isn't a dir or file, wtf man ?
262 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
263 echo
264 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
265 eerror
266 eerror " ${EPATCH_SOURCE}"
267 eerror " ( ${EPATCH_SOURCE##*/} )"
268 echo
269 die "Cannot find \$EPATCH_SOURCE!"
270 fi
271
272 local PIPE_CMD
273 case ${EPATCH_SUFFIX##*\.} in
274 xz) PIPE_CMD="xz -dc" ;;
275 lzma) PIPE_CMD="lzma -dc" ;;
276 bz2) PIPE_CMD="bzip2 -dc" ;;
277 gz|Z|z) PIPE_CMD="gzip -dc" ;;
278 ZIP|zip) PIPE_CMD="unzip -p" ;;
279 *) ;;
280 esac
281
282 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
283
137 local x="" 284 local x
285 for x in "$@" ; do
286 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
287 # didn't match anything, ignore continue on
288 [[ ! -f ${x} ]] && continue
138 289
139 if [ "$#" -gt 1 ] 290 local patchname=${x##*/}
291
292 # Apply single patches, or forced sets of patches, or
293 # patches with ARCH dependant names.
294 # ???_arch_foo.patch
295 # Else, skip this input altogether
296 local a=${patchname#*_} # strip the ???_
297 a=${a%%_*} # strip the _foo.patch
298 if ! [[ ${SINGLE_PATCH} == "yes" || \
299 ${EPATCH_FORCE} == "yes" || \
300 ${a} == all || \
301 ${a} == ${ARCH} ]]
302 then
303 continue
304 fi
305
306 # Let people filter things dynamically
307 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
308 # let people use globs in the exclude
309 eshopts_push -o noglob
310
311 local ex
312 for ex in ${EPATCH_EXCLUDE} ; do
313 if [[ ${patchname} == ${ex} ]] ; then
314 eshopts_pop
315 continue 2
316 fi
317 done
318
319 eshopts_pop
320 fi
321
322 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
323 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
324 einfo "${EPATCH_SINGLE_MSG}"
325 else
326 einfo "Applying ${patchname} ..."
327 fi
328 else
329 einfo " ${patchname} ..."
330 fi
331
332 # most of the time, there will only be one run per unique name,
333 # but if there are more, make sure we get unique log filenames
334 local STDERR_TARGET="${T}/${patchname}.out"
335 if [[ -e ${STDERR_TARGET} ]] ; then
336 STDERR_TARGET="${T}/${patchname}-$$.out"
337 fi
338
339 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
340
341 # Decompress the patch if need be
342 local count=0
343 local PATCH_TARGET
344 if [[ -n ${PIPE_CMD} ]] ; then
345 PATCH_TARGET="${T}/$$.patch"
346 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
347
348 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
349 echo
350 eerror "Could not extract patch!"
351 #die "Could not extract patch!"
352 count=5
353 break
354 fi
355 else
356 PATCH_TARGET=${x}
357 fi
358
359 # Check for absolute paths in patches. If sandbox is disabled,
360 # people could (accidently) patch files in the root filesystem.
361 # Or trigger other unpleasantries #237667. So disallow -p0 on
362 # such patches.
363 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
364 if [[ -n ${abs_paths} ]] ; then
365 count=1
366 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
367 fi
368 # Similar reason, but with relative paths.
369 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
370 if [[ -n ${rel_paths} ]] ; then
371 eqawarn "QA Notice: Your patch uses relative paths '../'."
372 eqawarn " In the future this will cause a failure."
373 eqawarn "${rel_paths}"
374 fi
375
376 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
377 while [[ ${count} -lt 5 ]] ; do
378 # Generate some useful debug info ...
379 (
380 _epatch_draw_line "***** ${patchname} *****"
381 echo
382 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
383 echo
384 _epatch_draw_line "***** ${patchname} *****"
385 ) >> "${STDERR_TARGET}"
386
387 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
388 (
389 _epatch_draw_line "***** ${patchname} *****"
390 echo
391 echo "ACTUALLY APPLYING ${patchname} ..."
392 echo
393 _epatch_draw_line "***** ${patchname} *****"
394 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
395 ) >> "${STDERR_TARGET}"
396
397 if [ $? -ne 0 ] ; then
398 echo
399 eerror "A dry-run of patch command succeeded, but actually"
400 eerror "applying the patch failed!"
401 #die "Real world sux compared to the dreamworld!"
402 count=5
403 fi
404 break
405 fi
406
407 : $(( count++ ))
408 done
409
410 # if we had to decompress the patch, delete the temp one
411 if [[ -n ${PIPE_CMD} ]] ; then
412 rm -f "${PATCH_TARGET}"
413 fi
414
415 if [[ ${count} -ge 5 ]] ; then
416 echo
417 eerror "Failed Patch: ${patchname} !"
418 eerror " ( ${PATCH_TARGET} )"
419 eerror
420 eerror "Include in your bugreport the contents of:"
421 eerror
422 eerror " ${STDERR_TARGET}"
423 echo
424 die "Failed Patch: ${patchname}!"
425 fi
426
427 # if everything worked, delete the patch log
428 rm -f "${STDERR_TARGET}"
429 eend 0
430 done
431
432 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
433 : # everything worked
434}
435epatch_user() {
436 [[ $# -ne 0 ]] && die "epatch_user takes no options"
437
438 # don't clobber any EPATCH vars that the parent might want
439 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
440 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
441 EPATCH_SOURCE=${base}/${CTARGET}/${check}
442 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
443 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
444 if [[ -d ${EPATCH_SOURCE} ]] ; then
445 EPATCH_SOURCE=${EPATCH_SOURCE} \
446 EPATCH_SUFFIX="patch" \
447 EPATCH_FORCE="yes" \
448 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
449 epatch
450 return 0
451 fi
452 done
453 return 1
454}
455
456# @FUNCTION: emktemp
457# @USAGE: [temp dir]
458# @DESCRIPTION:
459# Cheap replacement for when debianutils (and thus mktemp)
460# does not exist on the users system.
461emktemp() {
462 local exe="touch"
463 [[ $1 == -d ]] && exe="mkdir" && shift
464 local topdir=$1
465
466 if [[ -z ${topdir} ]] ; then
467 [[ -z ${T} ]] \
468 && topdir="/tmp" \
469 || topdir=${T}
470 fi
471
472 if ! type -P mktemp > /dev/null ; then
473 # system lacks `mktemp` so we have to fake it
474 local tmp=/
475 while [[ -e ${tmp} ]] ; do
476 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
477 done
478 ${exe} "${tmp}" || ${exe} -p "${tmp}"
479 echo "${tmp}"
480 else
481 # the args here will give slightly wierd names on BSD,
482 # but should produce a usable file on all userlands
483 if [[ ${exe} == "touch" ]] ; then
484 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
485 else
486 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
487 fi
488 fi
489}
490
491# @FUNCTION: egetent
492# @USAGE: <database> <key>
493# @MAINTAINER:
494# base-system@gentoo.org (Linux)
495# Joe Jezak <josejx@gmail.com> (OS X)
496# usata@gentoo.org (OS X)
497# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
498# @DESCRIPTION:
499# Small wrapper for getent (Linux),
500# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
501# and pw (FreeBSD) used in enewuser()/enewgroup()
502egetent() {
503 case ${CHOST} in
504 *-darwin[678])
505 case "$2" in
506 *[!0-9]*) # Non numeric
507 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
508 ;;
509 *) # Numeric
510 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
511 ;;
512 esac
513 ;;
514 *-darwin*)
515 local mytype=$1
516 [[ "passwd" == $mytype ]] && mytype="Users"
517 [[ "group" == $mytype ]] && mytype="Groups"
518 case "$2" in
519 *[!0-9]*) # Non numeric
520 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
521 ;;
522 *) # Numeric
523 local mykey="UniqueID"
524 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
525 dscl . -search /$mytype $mykey $2 2>/dev/null
526 ;;
527 esac
528 ;;
529 *-freebsd*|*-dragonfly*)
530 local opts action="user"
531 [[ $1 == "passwd" ]] || action="group"
532
533 # lookup by uid/gid
534 if [[ $2 == [[:digit:]]* ]] ; then
535 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
536 fi
537
538 pw show ${action} ${opts} "$2" -q
539 ;;
540 *-netbsd*|*-openbsd*)
541 grep "$2:\*:" /etc/$1
542 ;;
543 *)
544 type -p nscd >& /dev/null && nscd -i "$1"
545 getent "$1" "$2"
546 ;;
547 esac
548}
549
550# @FUNCTION: enewuser
551# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
552# @DESCRIPTION:
553# Same as enewgroup, you are not required to understand how to properly add
554# a user to the system. The only required parameter is the username.
555# Default uid is (pass -1 for this) next available, default shell is
556# /bin/false, default homedir is /dev/null, there are no default groups,
557# and default params sets the comment as 'added by portage for ${PN}'.
558enewuser() {
559 case ${EBUILD_PHASE} in
560 unpack|compile|test|install)
561 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
562 eerror "Package fails at QA and at life. Please file a bug."
563 die "Bad package! enewuser is only for use in pkg_* functions!"
564 esac
565
566 # get the username
567 local euser=$1; shift
568 if [[ -z ${euser} ]] ; then
569 eerror "No username specified !"
570 die "Cannot call enewuser without a username"
571 fi
572
573 # lets see if the username already exists
574 if [[ -n $(egetent passwd "${euser}") ]] ; then
575 return 0
576 fi
577 einfo "Adding user '${euser}' to your system ..."
578
579 # options to pass to useradd
580 local opts=
581
582 # handle uid
583 local euid=$1; shift
584 if [[ -n ${euid} && ${euid} != -1 ]] ; then
585 if [[ ${euid} -gt 0 ]] ; then
586 if [[ -n $(egetent passwd ${euid}) ]] ; then
587 euid="next"
588 fi
589 else
590 eerror "Userid given but is not greater than 0 !"
591 die "${euid} is not a valid UID"
592 fi
593 else
594 euid="next"
595 fi
596 if [[ ${euid} == "next" ]] ; then
597 for ((euid = 101; euid <= 999; euid++)); do
598 [[ -z $(egetent passwd ${euid}) ]] && break
599 done
600 fi
601 opts="${opts} -u ${euid}"
602 einfo " - Userid: ${euid}"
603
604 # handle shell
605 local eshell=$1; shift
606 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
607 if [[ ! -e ${ROOT}${eshell} ]] ; then
608 eerror "A shell was specified but it does not exist !"
609 die "${eshell} does not exist in ${ROOT}"
610 fi
611 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
612 eerror "Do not specify ${eshell} yourself, use -1"
613 die "Pass '-1' as the shell parameter"
614 fi
615 else
616 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
617 [[ -x ${ROOT}${shell} ]] && break
618 done
619
620 if [[ ${shell} == "/dev/null" ]] ; then
621 eerror "Unable to identify the shell to use, proceeding with userland default."
622 case ${USERLAND} in
623 GNU) shell="/bin/false" ;;
624 BSD) shell="/sbin/nologin" ;;
625 Darwin) shell="/usr/sbin/nologin" ;;
626 *) die "Unable to identify the default shell for userland ${USERLAND}"
627 esac
628 fi
629
630 eshell=${shell}
631 fi
632 einfo " - Shell: ${eshell}"
633 opts="${opts} -s ${eshell}"
634
635 # handle homedir
636 local ehome=$1; shift
637 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
638 ehome="/dev/null"
639 fi
640 einfo " - Home: ${ehome}"
641 opts="${opts} -d ${ehome}"
642
643 # handle groups
644 local egroups=$1; shift
645 if [[ ! -z ${egroups} ]] ; then
646 local oldifs=${IFS}
647 local defgroup="" exgroups=""
648
649 export IFS=","
650 for g in ${egroups} ; do
651 export IFS=${oldifs}
652 if [[ -z $(egetent group "${g}") ]] ; then
653 eerror "You must add group ${g} to the system first"
654 die "${g} is not a valid GID"
655 fi
656 if [[ -z ${defgroup} ]] ; then
657 defgroup=${g}
658 else
659 exgroups="${exgroups},${g}"
660 fi
661 export IFS=","
662 done
663 export IFS=${oldifs}
664
665 opts="${opts} -g ${defgroup}"
666 if [[ ! -z ${exgroups} ]] ; then
667 opts="${opts} -G ${exgroups:1}"
668 fi
669 else
670 egroups="(none)"
671 fi
672 einfo " - Groups: ${egroups}"
673
674 # handle extra and add the user
675 local oldsandbox=${SANDBOX_ON}
676 export SANDBOX_ON="0"
677 case ${CHOST} in
678 *-darwin*)
679 ### Make the user
680 if [[ -z $@ ]] ; then
681 dscl . create /users/${euser} uid ${euid}
682 dscl . create /users/${euser} shell ${eshell}
683 dscl . create /users/${euser} home ${ehome}
684 dscl . create /users/${euser} realname "added by portage for ${PN}"
685 ### Add the user to the groups specified
686 local oldifs=${IFS}
687 export IFS=","
688 for g in ${egroups} ; do
689 dscl . merge /groups/${g} users ${euser}
690 done
691 export IFS=${oldifs}
692 else
693 einfo "Extra options are not supported on Darwin yet"
694 einfo "Please report the ebuild along with the info below"
695 einfo "eextra: $@"
696 die "Required function missing"
697 fi
698 ;;
699 *-freebsd*|*-dragonfly*)
700 if [[ -z $@ ]] ; then
701 pw useradd ${euser} ${opts} \
702 -c "added by portage for ${PN}" \
703 die "enewuser failed"
704 else
705 einfo " - Extra: $@"
706 pw useradd ${euser} ${opts} \
707 "$@" || die "enewuser failed"
708 fi
709 ;;
710
711 *-netbsd*)
712 if [[ -z $@ ]] ; then
713 useradd ${opts} ${euser} || die "enewuser failed"
714 else
715 einfo " - Extra: $@"
716 useradd ${opts} ${euser} "$@" || die "enewuser failed"
717 fi
718 ;;
719
720 *-openbsd*)
721 if [[ -z $@ ]] ; then
722 useradd -u ${euid} -s ${eshell} \
723 -d ${ehome} -c "Added by portage for ${PN}" \
724 -g ${egroups} ${euser} || die "enewuser failed"
725 else
726 einfo " - Extra: $@"
727 useradd -u ${euid} -s ${eshell} \
728 -d ${ehome} -c "Added by portage for ${PN}" \
729 -g ${egroups} ${euser} "$@" || die "enewuser failed"
730 fi
731 ;;
732
733 *)
734 if [[ -z $@ ]] ; then
735 useradd -r ${opts} \
736 -c "added by portage for ${PN}" \
737 ${euser} \
738 || die "enewuser failed"
739 else
740 einfo " - Extra: $@"
741 useradd -r ${opts} "$@" \
742 ${euser} \
743 || die "enewuser failed"
744 fi
745 ;;
746 esac
747
748 if [[ ! -e ${ROOT}/${ehome} ]] ; then
749 einfo " - Creating ${ehome} in ${ROOT}"
750 mkdir -p "${ROOT}/${ehome}"
751 chown ${euser} "${ROOT}/${ehome}"
752 chmod 755 "${ROOT}/${ehome}"
753 fi
754
755 export SANDBOX_ON=${oldsandbox}
756}
757
758# @FUNCTION: enewgroup
759# @USAGE: <group> [gid]
760# @DESCRIPTION:
761# This function does not require you to understand how to properly add a
762# group to the system. Just give it a group name to add and enewgroup will
763# do the rest. You may specify the gid for the group or allow the group to
764# allocate the next available one.
765enewgroup() {
766 case ${EBUILD_PHASE} in
767 unpack|compile|test|install)
768 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
769 eerror "Package fails at QA and at life. Please file a bug."
770 die "Bad package! enewgroup is only for use in pkg_* functions!"
771 esac
772
773 # get the group
774 local egroup="$1"; shift
775 if [ -z "${egroup}" ]
140 then 776 then
141 eerror "Invalid arguments to epatch()" 777 eerror "No group specified !"
142 die "Invalid arguments to epatch()" 778 die "Cannot call enewgroup without a group"
143 fi 779 fi
144 780
145 if [ -n "$1" -a -f "$1" ] 781 # see if group already exists
782 if [[ -n $(egetent group "${egroup}") ]]; then
783 return 0
784 fi
785 einfo "Adding group '${egroup}' to your system ..."
786
787 # options to pass to useradd
788 local opts=
789
790 # handle gid
791 local egid="$1"; shift
792 if [ ! -z "${egid}" ]
146 then 793 then
147 SINGLE_PATCH="yes" 794 if [ "${egid}" -gt 0 ]
148
149 local EPATCH_SOURCE="$1"
150 local EPATCH_SUFFIX="${1##*\.}"
151
152 elif [ -n "$1" -a -d "$1" ]
153 then 795 then
154 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 796 if [ -z "`egetent group ${egid}`" ]
797 then
798 if [[ "${CHOST}" == *-darwin* ]]; then
799 opts="${opts} ${egid}"
800 else
801 opts="${opts} -g ${egid}"
802 fi
803 else
804 egid="next available; requested gid taken"
805 fi
806 else
807 eerror "Groupid given but is not greater than 0 !"
808 die "${egid} is not a valid GID"
809 fi
155 else 810 else
156 if [ ! -d ${EPATCH_SOURCE} ] 811 egid="next available"
812 fi
813 einfo " - Groupid: ${egid}"
814
815 # handle extra
816 local eextra="$@"
817 opts="${opts} ${eextra}"
818
819 # add the group
820 local oldsandbox="${SANDBOX_ON}"
821 export SANDBOX_ON="0"
822 case ${CHOST} in
823 *-darwin*)
824 if [ ! -z "${eextra}" ];
157 then 825 then
158 echo 826 einfo "Extra options are not supported on Darwin/OS X yet"
159 eerror "Cannot find \$EPATCH_SOURCE!" 827 einfo "Please report the ebuild along with the info below"
160 echo 828 einfo "eextra: ${eextra}"
161 die "Cannot find \$EPATCH_SOURCE!" 829 die "Required function missing"
162 fi
163
164 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
165 fi 830 fi
166 831
167 case ${EPATCH_SUFFIX##*\.} in 832 # If we need the next available
168 bz2) 833 case ${egid} in
169 PIPE_CMD="bzip2 -dc" 834 *[!0-9]*) # Non numeric
170 PATCH_SUFFIX="bz2" 835 for ((egid = 101; egid <= 999; egid++)); do
836 [[ -z $(egetent group ${egid}) ]] && break
837 done
838 esac
839 dscl . create /groups/${egroup} gid ${egid}
840 dscl . create /groups/${egroup} passwd '*'
841 ;;
842
843 *-freebsd*|*-dragonfly*)
844 case ${egid} in
845 *[!0-9]*) # Non numeric
846 for ((egid = 101; egid <= 999; egid++)); do
847 [[ -z $(egetent group ${egid}) ]] && break
848 done
849 esac
850 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
851 ;;
852
853 *-netbsd*)
854 case ${egid} in
855 *[!0-9]*) # Non numeric
856 for ((egid = 101; egid <= 999; egid++)); do
857 [[ -z $(egetent group ${egid}) ]] && break
858 done
859 esac
860 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
861 ;;
862
863 *)
864 # We specify -r so that we get a GID in the system range from login.defs
865 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
866 ;;
867 esac
868 export SANDBOX_ON="${oldsandbox}"
869}
870
871# @FUNCTION: edos2unix
872# @USAGE: <file> [more files ...]
873# @DESCRIPTION:
874# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
875# to remove all of these text utilities from DEPEND variables because this
876# is a script based solution. Just give it a list of files to convert and
877# they will all be changed from the DOS CRLF format to the UNIX LF format.
878edos2unix() {
879 echo "$@" | xargs sed -i 's/\r$//'
880}
881
882# Make a desktop file !
883# Great for making those icons in kde/gnome startmenu !
884# Amaze your friends ! Get the women ! Join today !
885#
886# make_desktop_entry(<command>, [name], [icon], [type], [fields])
887#
888# binary: what command does the app run with ?
889# name: the name that will show up in the menu
890# icon: give your little like a pretty little icon ...
891# this can be relative (to /usr/share/pixmaps) or
892# a full path to an icon
893# type: what kind of application is this ? for categories:
894# http://standards.freedesktop.org/menu-spec/latest/apa.html
895# fields: extra fields to append to the desktop file; a printf string
896make_desktop_entry() {
897 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
898
899 local exec=${1}
900 local name=${2:-${PN}}
901 local icon=${3:-${PN}}
902 local type=${4}
903 local fields=${5}
904
905 if [[ -z ${type} ]] ; then
906 local catmaj=${CATEGORY%%-*}
907 local catmin=${CATEGORY##*-}
908 case ${catmaj} in
909 app)
910 case ${catmin} in
911 accessibility) type=Accessibility;;
912 admin) type=System;;
913 antivirus) type=System;;
914 arch) type=Archiving;;
915 backup) type=Archiving;;
916 cdr) type=DiscBurning;;
917 dicts) type=Dictionary;;
918 doc) type=Documentation;;
919 editors) type=TextEditor;;
920 emacs) type=TextEditor;;
921 emulation) type=Emulator;;
922 laptop) type=HardwareSettings;;
923 office) type=Office;;
924 pda) type=PDA;;
925 vim) type=TextEditor;;
926 xemacs) type=TextEditor;;
927 esac
928 ;;
929
930 dev)
931 type="Development"
932 ;;
933
934 games)
935 case ${catmin} in
936 action|fps) type=ActionGame;;
937 arcade) type=ArcadeGame;;
938 board) type=BoardGame;;
939 emulation) type=Emulator;;
940 kids) type=KidsGame;;
941 puzzle) type=LogicGame;;
942 roguelike) type=RolePlaying;;
943 rpg) type=RolePlaying;;
944 simulation) type=Simulation;;
945 sports) type=SportsGame;;
946 strategy) type=StrategyGame;;
947 esac
948 type="Game;${type}"
949 ;;
950
951 gnome)
952 type="Gnome;GTK"
953 ;;
954
955 kde)
956 type="KDE;Qt"
957 ;;
958
959 mail)
960 type="Network;Email"
961 ;;
962
963 media)
964 case ${catmin} in
965 gfx)
966 type=Graphics
967 ;;
968 *)
969 case ${catmin} in
970 radio) type=Tuner;;
971 sound) type=Audio;;
972 tv) type=TV;;
973 video) type=Video;;
974 esac
975 type="AudioVideo;${type}"
976 ;;
977 esac
978 ;;
979
980 net)
981 case ${catmin} in
982 dialup) type=Dialup;;
983 ftp) type=FileTransfer;;
984 im) type=InstantMessaging;;
985 irc) type=IRCClient;;
986 mail) type=Email;;
987 news) type=News;;
988 nntp) type=News;;
989 p2p) type=FileTransfer;;
990 voip) type=Telephony;;
991 esac
992 type="Network;${type}"
993 ;;
994
995 sci)
996 case ${catmin} in
997 astro*) type=Astronomy;;
998 bio*) type=Biology;;
999 calc*) type=Calculator;;
1000 chem*) type=Chemistry;;
1001 elec*) type=Electronics;;
1002 geo*) type=Geology;;
1003 math*) type=Math;;
1004 physics) type=Physics;;
1005 visual*) type=DataVisualization;;
1006 esac
1007 type="Education;Science;${type}"
1008 ;;
1009
1010 sys)
1011 type="System"
1012 ;;
1013
1014 www)
1015 case ${catmin} in
1016 client) type=WebBrowser;;
1017 esac
1018 type="Network;${type}"
1019 ;;
1020
1021 *)
1022 type=
1023 ;;
1024 esac
1025 fi
1026 if [ "${SLOT}" == "0" ] ; then
1027 local desktop_name="${PN}"
1028 else
1029 local desktop_name="${PN}-${SLOT}"
1030 fi
1031 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
1032 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
1033
1034 # Don't append another ";" when a valid category value is provided.
1035 type=${type%;}${type:+;}
1036
1037 eshopts_push -s extglob
1038 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1039 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1040 ewarn "allowed in .desktop files if the value is not an absolute path."
1041 icon=${icon%.@(xpm|png|svg)}
1042 fi
1043 eshopts_pop
1044
1045 cat <<-EOF > "${desktop}"
1046 [Desktop Entry]
1047 Name=${name}
1048 Type=Application
1049 Comment=${DESCRIPTION}
1050 Exec=${exec}
1051 TryExec=${exec%% *}
1052 Icon=${icon}
1053 Categories=${type}
1054 EOF
1055
1056 if [[ ${fields:-=} != *=* ]] ; then
1057 # 5th arg used to be value to Path=
1058 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1059 fields="Path=${fields}"
1060 fi
1061 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1062
1063 (
1064 # wrap the env here so that the 'insinto' call
1065 # doesn't corrupt the env of the caller
1066 insinto /usr/share/applications
1067 doins "${desktop}"
1068 ) || die "installing desktop file failed"
1069}
1070
1071# @FUNCTION: validate_desktop_entries
1072# @USAGE: [directories]
1073# @MAINTAINER:
1074# Carsten Lohrke <carlo@gentoo.org>
1075# @DESCRIPTION:
1076# Validate desktop entries using desktop-file-utils
1077validate_desktop_entries() {
1078 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1079 einfo "Checking desktop entry validity"
1080 local directories=""
1081 for d in /usr/share/applications $@ ; do
1082 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1083 done
1084 if [[ -n ${directories} ]] ; then
1085 for FILE in $(find ${directories} -name "*\.desktop" \
1086 -not -path '*.hidden*' | sort -u 2>/dev/null)
1087 do
1088 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1089 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1090 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1091 done
1092 fi
1093 echo ""
1094 else
1095 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1096 fi
1097}
1098
1099# @FUNCTION: make_session_desktop
1100# @USAGE: <title> <command> [command args...]
1101# @DESCRIPTION:
1102# Make a GDM/KDM Session file. The title is the file to execute to start the
1103# Window Manager. The command is the name of the Window Manager.
1104#
1105# You can set the name of the file via the ${wm} variable.
1106make_session_desktop() {
1107 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1108 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1109
1110 local title=$1
1111 local command=$2
1112 local desktop=${T}/${wm:-${PN}}.desktop
1113 shift 2
1114
1115 cat <<-EOF > "${desktop}"
1116 [Desktop Entry]
1117 Name=${title}
1118 Comment=This session logs you into ${title}
1119 Exec=${command} $*
1120 TryExec=${command}
1121 Type=XSession
1122 EOF
1123
1124 (
1125 # wrap the env here so that the 'insinto' call
1126 # doesn't corrupt the env of the caller
1127 insinto /usr/share/xsessions
1128 doins "${desktop}"
1129 )
1130}
1131
1132# @FUNCTION: domenu
1133# @USAGE: <menus>
1134# @DESCRIPTION:
1135# Install the list of .desktop menu files into the appropriate directory
1136# (/usr/share/applications).
1137domenu() {
1138 (
1139 # wrap the env here so that the 'insinto' call
1140 # doesn't corrupt the env of the caller
1141 local i j ret=0
1142 insinto /usr/share/applications
1143 for i in "$@" ; do
1144 if [[ -f ${i} ]] ; then
1145 doins "${i}"
1146 ((ret+=$?))
1147 elif [[ -d ${i} ]] ; then
1148 for j in "${i}"/*.desktop ; do
1149 doins "${j}"
1150 ((ret+=$?))
1151 done
1152 else
1153 ((++ret))
1154 fi
1155 done
1156 exit ${ret}
1157 )
1158}
1159
1160# @FUNCTION: newmenu
1161# @USAGE: <menu> <newname>
1162# @DESCRIPTION:
1163# Like all other new* functions, install the specified menu as newname.
1164newmenu() {
1165 (
1166 # wrap the env here so that the 'insinto' call
1167 # doesn't corrupt the env of the caller
1168 insinto /usr/share/applications
1169 newins "$@"
1170 )
1171}
1172
1173# @FUNCTION: doicon
1174# @USAGE: <list of icons>
1175# @DESCRIPTION:
1176# Install the list of icons into the icon directory (/usr/share/pixmaps).
1177# This is useful in conjunction with creating desktop/menu files.
1178doicon() {
1179 (
1180 # wrap the env here so that the 'insinto' call
1181 # doesn't corrupt the env of the caller
1182 local i j ret
1183 insinto /usr/share/pixmaps
1184 for i in "$@" ; do
1185 if [[ -f ${i} ]] ; then
1186 doins "${i}"
1187 ((ret+=$?))
1188 elif [[ -d ${i} ]] ; then
1189 for j in "${i}"/*.png ; do
1190 doins "${j}"
1191 ((ret+=$?))
1192 done
1193 else
1194 ((++ret))
1195 fi
1196 done
1197 exit ${ret}
1198 )
1199}
1200
1201# @FUNCTION: newicon
1202# @USAGE: <icon> <newname>
1203# @DESCRIPTION:
1204# Like all other new* functions, install the specified icon as newname.
1205newicon() {
1206 (
1207 # wrap the env here so that the 'insinto' call
1208 # doesn't corrupt the env of the caller
1209 insinto /usr/share/pixmaps
1210 newins "$@"
1211 )
1212}
1213
1214# for internal use only (unpack_pdv and unpack_makeself)
1215find_unpackable_file() {
1216 local src=$1
1217 if [[ -z ${src} ]] ; then
1218 src=${DISTDIR}/${A}
1219 else
1220 if [[ -e ${DISTDIR}/${src} ]] ; then
1221 src=${DISTDIR}/${src}
1222 elif [[ -e ${PWD}/${src} ]] ; then
1223 src=${PWD}/${src}
1224 elif [[ -e ${src} ]] ; then
1225 src=${src}
1226 fi
1227 fi
1228 [[ ! -e ${src} ]] && return 1
1229 echo "${src}"
1230}
1231
1232# @FUNCTION: unpack_pdv
1233# @USAGE: <file to unpack> <size of off_t>
1234# @DESCRIPTION:
1235# Unpack those pesky pdv generated files ...
1236# They're self-unpacking programs with the binary package stuffed in
1237# the middle of the archive. Valve seems to use it a lot ... too bad
1238# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1239#
1240# You have to specify the off_t size ... I have no idea how to extract that
1241# information out of the binary executable myself. Basically you pass in
1242# the size of the off_t type (in bytes) on the machine that built the pdv
1243# archive.
1244#
1245# One way to determine this is by running the following commands:
1246#
1247# @CODE
1248# strings <pdv archive> | grep lseek
1249# strace -elseek <pdv archive>
1250# @CODE
1251#
1252# Basically look for the first lseek command (we do the strings/grep because
1253# sometimes the function call is _llseek or something) and steal the 2nd
1254# parameter. Here is an example:
1255#
1256# @CODE
1257# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1258# lseek
1259# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1260# lseek(3, -4, SEEK_END) = 2981250
1261# @CODE
1262#
1263# Thus we would pass in the value of '4' as the second parameter.
1264unpack_pdv() {
1265 local src=$(find_unpackable_file "$1")
1266 local sizeoff_t=$2
1267
1268 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1269 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1270
1271 local shrtsrc=$(basename "${src}")
1272 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1273 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1274 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1275
1276 # grab metadata for debug reasons
1277 local metafile=$(emktemp)
1278 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1279
1280 # rip out the final file name from the metadata
1281 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1282 datafile=$(basename "${datafile}")
1283
1284 # now lets uncompress/untar the file if need be
1285 local tmpfile=$(emktemp)
1286 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1287
1288 local iscompressed=$(file -b "${tmpfile}")
1289 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1290 iscompressed=1
1291 mv ${tmpfile}{,.Z}
1292 gunzip ${tmpfile}
1293 else
1294 iscompressed=0
1295 fi
1296 local istar=$(file -b "${tmpfile}")
1297 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1298 istar=1
1299 else
1300 istar=0
1301 fi
1302
1303 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1304 #dd if=${src} ibs=${metaskip} count=1 \
1305 # | dd ibs=${tailskip} skip=1 \
1306 # | gzip -dc \
1307 # > ${datafile}
1308 if [ ${iscompressed} -eq 1 ] ; then
1309 if [ ${istar} -eq 1 ] ; then
1310 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1311 | head -c $((${metaskip}-${tailskip})) \
1312 | tar -xzf -
1313 else
1314 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1315 | head -c $((${metaskip}-${tailskip})) \
1316 | gzip -dc \
1317 > ${datafile}
1318 fi
1319 else
1320 if [ ${istar} -eq 1 ] ; then
1321 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1322 | head -c $((${metaskip}-${tailskip})) \
1323 | tar --no-same-owner -xf -
1324 else
1325 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1326 | head -c $((${metaskip}-${tailskip})) \
1327 > ${datafile}
1328 fi
1329 fi
1330 true
1331 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1332 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1333}
1334
1335# @FUNCTION: unpack_makeself
1336# @USAGE: [file to unpack] [offset] [tail|dd]
1337# @DESCRIPTION:
1338# Unpack those pesky makeself generated files ...
1339# They're shell scripts with the binary package tagged onto
1340# the end of the archive. Loki utilized the format as does
1341# many other game companies.
1342#
1343# If the file is not specified, then ${A} is used. If the
1344# offset is not specified then we will attempt to extract
1345# the proper offset from the script itself.
1346unpack_makeself() {
1347 local src_input=${1:-${A}}
1348 local src=$(find_unpackable_file "${src_input}")
1349 local skip=$2
1350 local exe=$3
1351
1352 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1353
1354 local shrtsrc=$(basename "${src}")
1355 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1356 if [[ -z ${skip} ]] ; then
1357 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1358 local skip=0
1359 exe=tail
1360 case ${ver} in
1361 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1362 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1363 ;;
1364 2.0|2.0.1)
1365 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1366 ;;
1367 2.1.1)
1368 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1369 (( skip++ ))
1370 ;;
1371 2.1.2)
1372 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1373 (( skip++ ))
1374 ;;
1375 2.1.3)
1376 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1377 (( skip++ ))
1378 ;;
1379 2.1.4|2.1.5)
1380 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1381 skip=$(head -n ${skip} "${src}" | wc -c)
1382 exe="dd"
1383 ;;
1384 *)
1385 eerror "I'm sorry, but I was unable to support the Makeself file."
1386 eerror "The version I detected was '${ver}'."
1387 eerror "Please file a bug about the file ${shrtsrc} at"
1388 eerror "http://bugs.gentoo.org/ so that support can be added."
1389 die "makeself version '${ver}' not supported"
1390 ;;
1391 esac
1392 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1393 fi
1394 case ${exe} in
1395 tail) exe="tail -n +${skip} '${src}'";;
1396 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1397 *) die "makeself cant handle exe '${exe}'"
1398 esac
1399
1400 # lets grab the first few bytes of the file to figure out what kind of archive it is
1401 local filetype tmpfile=$(emktemp)
1402 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1403 filetype=$(file -b "${tmpfile}") || die
1404 case ${filetype} in
1405 *tar\ archive*)
1406 eval ${exe} | tar --no-same-owner -xf -
171 ;; 1407 ;;
172 gz|Z|z) 1408 bzip2*)
173 PIPE_CMD="gzip -dc" 1409 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
174 PATCH_SUFFIX="gz"
175 ;; 1410 ;;
176 ZIP|zip) 1411 gzip*)
177 PIPE_CMD="unzip -p" 1412 eval ${exe} | tar --no-same-owner -xzf -
178 PATCH_SUFFIX="zip" 1413 ;;
1414 compress*)
1415 eval ${exe} | gunzip | tar --no-same-owner -xf -
179 ;; 1416 ;;
180 *) 1417 *)
181 PIPE_CMD="cat" 1418 eerror "Unknown filetype \"${filetype}\" ?"
182 PATCH_SUFFIX="patch" 1419 false
183 ;; 1420 ;;
184 esac 1421 esac
1422 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1423}
185 1424
186 if [ "${SINGLE_PATCH}" = "no" ] 1425# @FUNCTION: check_license
187 then 1426# @USAGE: [license]
188 einfo "Applying various patches (bugfixes/updates)..." 1427# @DESCRIPTION:
1428# Display a license for user to accept. If no license is
1429# specified, then ${LICENSE} is used.
1430check_license() {
1431 local lic=$1
1432 if [ -z "${lic}" ] ; then
1433 lic="${PORTDIR}/licenses/${LICENSE}"
1434 else
1435 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1436 lic="${PORTDIR}/licenses/${lic}"
1437 elif [ -e "${PWD}/${lic}" ] ; then
1438 lic="${PWD}/${lic}"
1439 elif [ -e "${lic}" ] ; then
1440 lic="${lic}"
189 fi 1441 fi
190 for x in ${EPATCH_SOURCE} 1442 fi
1443 local l="`basename ${lic}`"
1444
1445 # here is where we check for the licenses the user already
1446 # accepted ... if we don't find a match, we make the user accept
1447 local alic
1448 eshopts_push -o noglob # so that bash doesn't expand "*"
1449 for alic in ${ACCEPT_LICENSE} ; do
1450 if [[ ${alic} == ${l} ]]; then
1451 eshopts_pop
1452 return 0
1453 fi
191 do 1454 done
192 # New ARCH dependant patch naming scheme... 1455 eshopts_pop
193 # 1456 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
194 # ???_arch_foo.patch 1457
195 # 1458 local licmsg=$(emktemp)
196 if [ -f ${x} ] && \ 1459 cat <<-EOF > ${licmsg}
197 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] 1460 **********************************************************
198 then 1461 The following license outlines the terms of use of this
1462 package. You MUST accept this license for installation to
1463 continue. When you are done viewing, hit 'q'. If you
1464 CTRL+C out of this, the install will not run!
1465 **********************************************************
1466
1467 EOF
1468 cat ${lic} >> ${licmsg}
1469 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1470 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1471 read alic
1472 case ${alic} in
1473 yes|Yes|y|Y)
1474 return 0
1475 ;;
1476 *)
1477 echo;echo;echo
1478 eerror "You MUST accept the license to continue! Exiting!"
1479 die "Failed to accept license"
1480 ;;
1481 esac
1482}
1483
1484# @FUNCTION: cdrom_get_cds
1485# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1486# @DESCRIPTION:
1487# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1488# the whole 'non-interactive' policy, but damnit I want CD support !
1489#
1490# With these cdrom functions we handle all the user interaction and
1491# standardize everything. All you have to do is call cdrom_get_cds()
1492# and when the function returns, you can assume that the cd has been
1493# found at CDROM_ROOT.
1494#
1495# The function will attempt to locate a cd based upon a file that is on
1496# the cd. The more files you give this function, the more cds
1497# the cdrom functions will handle.
1498#
1499# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1500# etc... If you want to give the cds better names, then just export
1501# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1502# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1503# also use the CDROM_NAME_SET bash array.
1504#
1505# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1506cdrom_get_cds() {
1507 # first we figure out how many cds we're dealing with by
1508 # the # of files they gave us
199 local count=0 1509 local cdcnt=0
200 local popts="${EPATCH_OPTS}" 1510 local f=
1511 for f in "$@" ; do
1512 ((++cdcnt))
1513 export CDROM_CHECK_${cdcnt}="$f"
1514 done
1515 export CDROM_TOTAL_CDS=${cdcnt}
1516 export CDROM_CURRENT_CD=1
201 1517
202 if [ -n "${EPATCH_EXCLUDE}" ] 1518 # now we see if the user gave use CD_ROOT ...
203 then 1519 # if they did, let's just believe them that it's correct
204 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ] 1520 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
205 then 1521 local var=
1522 cdcnt=0
1523 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1524 ((++cdcnt))
1525 var="CD_ROOT_${cdcnt}"
1526 [[ -z ${!var} ]] && var="CD_ROOT"
1527 if [[ -z ${!var} ]] ; then
1528 eerror "You must either use just the CD_ROOT"
1529 eerror "or specify ALL the CD_ROOT_X variables."
1530 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1531 die "could not locate CD_ROOT_${cdcnt}"
1532 fi
1533 done
1534 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1535 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1536 export CDROM_SET=-1
1537 for f in ${CDROM_CHECK_1//:/ } ; do
1538 ((++CDROM_SET))
1539 [[ -e ${CDROM_ROOT}/${f} ]] && break
1540 done
1541 export CDROM_MATCH=${f}
1542 return
1543 fi
1544
1545 # User didn't help us out so lets make sure they know they can
1546 # simplify the whole process ...
1547 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1548 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1549 echo
1550 einfo "If you do not have the CD, but have the data files"
1551 einfo "mounted somewhere on your filesystem, just export"
1552 einfo "the variable CD_ROOT so that it points to the"
1553 einfo "directory containing the files."
1554 echo
1555 einfo "For example:"
1556 einfo "export CD_ROOT=/mnt/cdrom"
1557 echo
1558 else
1559 if [[ -n ${CDROM_NAME_SET} ]] ; then
1560 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1561 cdcnt=0
1562 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1563 ((++cdcnt))
1564 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1565 done
1566 fi
1567
1568 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1569 cdcnt=0
1570 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1571 ((++cdcnt))
1572 var="CDROM_NAME_${cdcnt}"
1573 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1574 done
1575 echo
1576 einfo "If you do not have the CDs, but have the data files"
1577 einfo "mounted somewhere on your filesystem, just export"
1578 einfo "the following variables so they point to the right place:"
1579 einfon ""
1580 cdcnt=0
1581 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1582 ((++cdcnt))
1583 echo -n " CD_ROOT_${cdcnt}"
1584 done
1585 echo
1586 einfo "Or, if you have all the files in the same place, or"
1587 einfo "you only have one cdrom, you can export CD_ROOT"
1588 einfo "and that place will be used as the same data source"
1589 einfo "for all the CDs."
1590 echo
1591 einfo "For example:"
1592 einfo "export CD_ROOT_1=/mnt/cdrom"
1593 echo
1594 fi
1595
1596 export CDROM_SET=""
1597 export CDROM_CURRENT_CD=0
1598 cdrom_load_next_cd
1599}
1600
1601# @FUNCTION: cdrom_load_next_cd
1602# @DESCRIPTION:
1603# Some packages are so big they come on multiple CDs. When you're done reading
1604# files off a CD and want access to the next one, just call this function.
1605# Again, all the messy details of user interaction are taken care of for you.
1606# Once this returns, just read the variable CDROM_ROOT for the location of the
1607# mounted CD. Note that you can only go forward in the CD list, so make sure
1608# you only call this function when you're done using the current CD.
1609cdrom_load_next_cd() {
1610 local var
1611 ((++CDROM_CURRENT_CD))
1612
1613 unset CDROM_ROOT
1614 var=CD_ROOT_${CDROM_CURRENT_CD}
1615 [[ -z ${!var} ]] && var="CD_ROOT"
1616 if [[ -z ${!var} ]] ; then
1617 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1618 _cdrom_locate_file_on_cd ${!var}
1619 else
1620 export CDROM_ROOT=${!var}
1621 fi
1622
1623 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1624}
1625
1626# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1627# functions. this should *never* be called from an ebuild.
1628# all it does is try to locate a give file on a cd ... if the cd isn't
1629# found, then a message asking for the user to insert the cdrom will be
1630# displayed and we'll hang out here until:
1631# (1) the file is found on a mounted cdrom
1632# (2) the user hits CTRL+C
1633_cdrom_locate_file_on_cd() {
1634 local mline=""
1635 local showedmsg=0 showjolietmsg=0
1636
1637 while [[ -z ${CDROM_ROOT} ]] ; do
1638 local i=0
1639 local -a cdset=(${*//:/ })
1640 if [[ -n ${CDROM_SET} ]] ; then
1641 cdset=(${cdset[${CDROM_SET}]})
1642 fi
1643
1644 while [[ -n ${cdset[${i}]} ]] ; do
1645 local dir=$(dirname ${cdset[${i}]})
1646 local file=$(basename ${cdset[${i}]})
1647
1648 local point= node= fs= foo=
1649 while read point node fs foo ; do
1650 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1651 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
206 continue 1652 && continue
1653 point=${point//\040/ }
1654 [[ ! -d ${point}/${dir} ]] && continue
1655 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1656 export CDROM_ROOT=${point}
1657 export CDROM_SET=${i}
1658 export CDROM_MATCH=${cdset[${i}]}
1659 return
1660 done <<< "$(get_mounts)"
1661
1662 ((++i))
1663 done
1664
1665 echo
1666 if [[ ${showedmsg} -eq 0 ]] ; then
1667 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1668 if [[ -z ${CDROM_NAME} ]] ; then
1669 einfo "Please insert+mount the cdrom for ${PN} now !"
1670 else
1671 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1672 fi
1673 else
1674 if [[ -z ${CDROM_NAME_1} ]] ; then
1675 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1676 else
1677 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1678 einfo "Please insert+mount the ${!var} cdrom now !"
207 fi 1679 fi
208 fi 1680 fi
1681 showedmsg=1
1682 fi
1683 einfo "Press return to scan for the cd again"
1684 einfo "or hit CTRL+C to abort the emerge."
1685 echo
1686 if [[ ${showjolietmsg} -eq 0 ]] ; then
1687 showjolietmsg=1
1688 else
1689 ewarn "If you are having trouble with the detection"
1690 ewarn "of your CD, it is possible that you do not have"
1691 ewarn "Joliet support enabled in your kernel. Please"
1692 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1693 ebeep 5
1694 fi
1695 read || die "something is screwed with your system"
1696 done
1697}
1698
1699# @FUNCTION: strip-linguas
1700# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1701# @DESCRIPTION:
1702# Make sure that LINGUAS only contains languages that
1703# a package can support. The first form allows you to
1704# specify a list of LINGUAS. The -i builds a list of po
1705# files found in all the directories and uses the
1706# intersection of the lists. The -u builds a list of po
1707# files found in all the directories and uses the union
1708# of the lists.
1709strip-linguas() {
1710 local ls newls nols
1711 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1712 local op=$1; shift
1713 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1714 local d f
1715 for d in "$@" ; do
1716 if [[ ${op} == "-u" ]] ; then
1717 newls=${ls}
1718 else
1719 newls=""
209 1720 fi
210 if [ "${SINGLE_PATCH}" = "yes" ] 1721 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
211 then 1722 if [[ ${op} == "-i" ]] ; then
212 if [ -n "${EPATCH_SINGLE_MSG}" ] 1723 has ${f} ${ls} && newls="${newls} ${f}"
213 then
214 einfo "${EPATCH_SINGLE_MSG}"
215 else 1724 else
216 einfo "Applying ${x##*/}..." 1725 has ${f} ${ls} || newls="${newls} ${f}"
217 fi 1726 fi
1727 done
1728 ls=${newls}
1729 done
1730 else
1731 ls="$@"
1732 fi
1733
1734 nols=""
1735 newls=""
1736 for f in ${LINGUAS} ; do
1737 if has ${f} ${ls} ; then
1738 newls="${newls} ${f}"
218 else 1739 else
219 einfo " ${x##*/}..." 1740 nols="${nols} ${f}"
1741 fi
1742 done
1743 [[ -n ${nols} ]] \
1744 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1745 export LINGUAS=${newls:1}
1746}
1747
1748# @FUNCTION: preserve_old_lib
1749# @USAGE: <libs to preserve> [more libs]
1750# @DESCRIPTION:
1751# These functions are useful when a lib in your package changes ABI SONAME.
1752# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1753# would break packages that link against it. Most people get around this
1754# by using the portage SLOT mechanism, but that is not always a relevant
1755# solution, so instead you can call this from pkg_preinst. See also the
1756# preserve_old_lib_notify function.
1757preserve_old_lib() {
1758 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1759 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1760 die "Invalid preserve_old_lib() usage"
1761 fi
1762 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1763
1764 # let portage worry about it
1765 has preserve-libs ${FEATURES} && return 0
1766
1767 local lib dir
1768 for lib in "$@" ; do
1769 [[ -e ${ROOT}/${lib} ]] || continue
1770 dir=${lib%/*}
1771 dodir ${dir} || die "dodir ${dir} failed"
1772 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1773 touch "${D}"/${lib}
1774 done
1775}
1776
1777# @FUNCTION: preserve_old_lib_notify
1778# @USAGE: <libs to notify> [more libs]
1779# @DESCRIPTION:
1780# Spit helpful messages about the libraries preserved by preserve_old_lib.
1781preserve_old_lib_notify() {
1782 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1783 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1784 die "Invalid preserve_old_lib_notify() usage"
1785 fi
1786
1787 # let portage worry about it
1788 has preserve-libs ${FEATURES} && return 0
1789
1790 local lib notice=0
1791 for lib in "$@" ; do
1792 [[ -e ${ROOT}/${lib} ]] || continue
1793 if [[ ${notice} -eq 0 ]] ; then
1794 notice=1
1795 ewarn "Old versions of installed libraries were detected on your system."
1796 ewarn "In order to avoid breaking packages that depend on these old libs,"
1797 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1798 ewarn "in order to remove these old dependencies. If you do not have this"
1799 ewarn "helper program, simply emerge the 'gentoolkit' package."
1800 ewarn
1801 fi
1802 # temp hack for #348634 #357225
1803 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1804 ewarn " # revdep-rebuild --library '${lib}'"
1805 done
1806 if [[ ${notice} -eq 1 ]] ; then
1807 ewarn
1808 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1809 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1810 for lib in "$@" ; do
1811 ewarn " # rm '${lib}'"
1812 done
1813 fi
1814}
1815
1816# @FUNCTION: built_with_use
1817# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1818# @DESCRIPTION:
1819#
1820# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1821#
1822# A temporary hack until portage properly supports DEPENDing on USE
1823# flags being enabled in packages. This will check to see if the specified
1824# DEPEND atom was built with the specified list of USE flags. The
1825# --missing option controls the behavior if called on a package that does
1826# not actually support the defined USE flags (aka listed in IUSE).
1827# The default is to abort (call die). The -a and -o flags control
1828# the requirements of the USE flags. They correspond to "and" and "or"
1829# logic. So the -a flag means all listed USE flags must be enabled
1830# while the -o flag means at least one of the listed IUSE flags must be
1831# enabled. The --hidden option is really for internal use only as it
1832# means the USE flag we're checking is hidden expanded, so it won't be found
1833# in IUSE like normal USE flags.
1834#
1835# Remember that this function isn't terribly intelligent so order of optional
1836# flags matter.
1837built_with_use() {
1838 local hidden="no"
1839 if [[ $1 == "--hidden" ]] ; then
1840 hidden="yes"
1841 shift
1842 fi
1843
1844 local missing_action="die"
1845 if [[ $1 == "--missing" ]] ; then
1846 missing_action=$2
1847 shift ; shift
1848 case ${missing_action} in
1849 true|false|die) ;;
1850 *) die "unknown action '${missing_action}'";;
1851 esac
1852 fi
1853
1854 local opt=$1
1855 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1856
1857 local PKG=$(best_version $1)
1858 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1859 shift
1860
1861 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1862 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1863
1864 # if the IUSE file doesn't exist, the read will error out, we need to handle
1865 # this gracefully
1866 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1867 case ${missing_action} in
1868 true) return 0;;
1869 false) return 1;;
1870 die) die "Unable to determine what USE flags $PKG was built with";;
1871 esac
1872 fi
1873
1874 if [[ ${hidden} == "no" ]] ; then
1875 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1876 # Don't check USE_EXPAND #147237
1877 local expand
1878 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1879 if [[ $1 == ${expand}_* ]] ; then
1880 expand=""
1881 break
220 fi 1882 fi
221
222 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
223 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
224
225 # Allow for prefix to differ ... im lazy, so shoot me :/
226 while [ "${count}" -lt 5 ]
227 do
228 # Generate some useful debug info ...
229 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
230 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
231
232 if [ "${PATCH_SUFFIX}" != "patch" ]
233 then
234 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
235 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
236 else
237 PATCH_TARGET="${x}"
238 fi
239
240 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
241 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
242
243 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245
246 if [ "${PATCH_SUFFIX}" != "patch" ]
247 then
248 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
249 then
250 echo
251 eerror "Could not extract patch!"
252 #die "Could not extract patch!"
253 count=5
254 break
255 fi
256 fi
257
258 if patch ${popts} --dry-run -f -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
259 then
260 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
261 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
262 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
263 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
264 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
265
266 patch ${popts} -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
267
268 if [ "$?" -ne 0 ]
269 then
270 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
271 echo
272 eerror "A dry-run of patch command succeeded, but actually"
273 eerror "applying the patch failed!"
274 #die "Real world sux compared to the dreamworld!"
275 count=5
276 fi
277
278 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
279
280 break
281 fi
282
283 count=$((count + 1))
284 done 1883 done
285 1884 if [[ -n ${expand} ]] ; then
286 if [ "${PATCH_SUFFIX}" != "patch" ] 1885 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
287 then 1886 case ${missing_action} in
288 rm -f ${PATCH_TARGET} 1887 true) return 0;;
1888 false) return 1;;
1889 die) die "$PKG does not actually support the $1 USE flag!";;
1890 esac
289 fi 1891 fi
290
291 if [ "${count}" -eq 5 ]
292 then
293 echo
294 eerror "Failed Patch: ${x##*/}!"
295 eerror
296 eerror "Include in your bugreport the contents of:"
297 eerror
298 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
299 echo
300 die "Failed Patch: ${x##*/}!"
301 fi 1892 fi
302
303 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
304
305 eend 0
306 fi 1893 fi
1894
1895 local USE_BUILT=$(<${USEFILE})
1896 while [[ $# -gt 0 ]] ; do
1897 if [[ ${opt} = "-o" ]] ; then
1898 has $1 ${USE_BUILT} && return 0
1899 else
1900 has $1 ${USE_BUILT} || return 1
1901 fi
1902 shift
307 done 1903 done
308 if [ "${SINGLE_PATCH}" = "no" ] 1904 [[ ${opt} = "-a" ]]
309 then 1905}
310 einfo "Done with patching" 1906
1907# @FUNCTION: epunt_cxx
1908# @USAGE: [dir to scan]
1909# @DESCRIPTION:
1910# Many configure scripts wrongly bail when a C++ compiler could not be
1911# detected. If dir is not specified, then it defaults to ${S}.
1912#
1913# http://bugs.gentoo.org/73450
1914epunt_cxx() {
1915 local dir=$1
1916 [[ -z ${dir} ]] && dir=${S}
1917 ebegin "Removing useless C++ checks"
1918 local f
1919 find "${dir}" -name configure | while read f ; do
1920 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1921 done
1922 eend 0
1923}
1924
1925# @FUNCTION: make_wrapper
1926# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1927# @DESCRIPTION:
1928# Create a shell wrapper script named wrapper in installpath
1929# (defaults to the bindir) to execute target (default of wrapper) by
1930# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1931# libpaths followed by optionally changing directory to chdir.
1932make_wrapper() {
1933 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1934 local tmpwrapper=$(emktemp)
1935 # We don't want to quote ${bin} so that people can pass complex
1936 # things as $bin ... "./someprog --args"
1937 cat << EOF > "${tmpwrapper}"
1938#!/bin/sh
1939cd "${chdir:-.}"
1940if [ -n "${libdir}" ] ; then
1941 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1942 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1943 else
1944 export LD_LIBRARY_PATH="${libdir}"
1945 fi
311 fi 1946fi
1947exec ${bin} "\$@"
1948EOF
1949 chmod go+rx "${tmpwrapper}"
1950 if [[ -n ${path} ]] ; then
1951 (
1952 exeinto "${path}"
1953 newexe "${tmpwrapper}" "${wrapper}"
1954 ) || die
1955 else
1956 newbin "${tmpwrapper}" "${wrapper}" || die
1957 fi
312} 1958}
313 1959
1960# @FUNCTION: path_exists
1961# @USAGE: [-a|-o] <paths>
1962# @DESCRIPTION:
1963# Check if the specified paths exist. Works for all types of paths
1964# (files/dirs/etc...). The -a and -o flags control the requirements
1965# of the paths. They correspond to "and" and "or" logic. So the -a
1966# flag means all the paths must exist while the -o flag means at least
1967# one of the paths must exist. The default behavior is "and". If no
1968# paths are specified, then the return value is "false".
1969path_exists() {
1970 local opt=$1
1971 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1972
1973 # no paths -> return false
1974 # same behavior as: [[ -e "" ]]
1975 [[ $# -eq 0 ]] && return 1
1976
1977 local p r=0
1978 for p in "$@" ; do
1979 [[ -e ${p} ]]
1980 : $(( r += $? ))
1981 done
1982
1983 case ${opt} in
1984 -a) return $(( r != 0 )) ;;
1985 -o) return $(( r == $# )) ;;
1986 esac
1987}

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.359

  ViewVC Help
Powered by ViewVC 1.1.20